Bug 1471030 - mmc0: Unknown controller version (16). O2 Micro Integrated MMC/SD Controller (rev 01)
mmc0: Unknown controller version (16). O2 Micro Integrated MMC/SD Controller ...
Status: NEW
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
27
x86_64 Linux
unspecified Severity high
: ---
: ---
Assigned To: Kernel Maintainer List
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2017-07-14 05:43 EDT by feder
Modified: 2018-02-28 01:30 EST (History)
8 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description feder 2017-07-14 05:43:15 EDT
Description of problem:
O2 Micro, Inc. Integrated MMC/SD Controller (rev 01) does not work.


Version-Release number of selected component (if applicable):
kernel 4.11.9-300.fc26.x86_64


How reproducible:
It's reproducible on any hardware with integrated O2 Micro MMC/SD Controller (rev 01).


Steps to Reproduce:
1. Check dmesg after system boots up.
2. Insert the SD Card into the card reader slot.


Actual results:
During boot:
[    4.277691] mmc0: Unknown controller version (16). You may experience problems.
After inserting any SD Card:
[  716.767538] mmc0: Timeout waiting for hardware cmd interrupt.
[  716.767549] sdhci: =========== REGISTER DUMP (mmc0)===========
[  716.767557] sdhci: Sys addr: 0x00000000 | Version:  0x00001010
[  716.767563] sdhci: Blk size: 0x00000000 | Blk cnt:  0x00000000
[  716.767570] sdhci: Argument: 0x00000c00 | Trn mode: 0x00000000
[  716.767576] sdhci: Present:  0x01ff0001 | Host ctl: 0x00000001
[  716.767582] sdhci: Power:    0x0000000f | Blk gap:  0x00000000
[  716.767588] sdhci: Wake-up:  0x00000000 | Clock:    0x00002a07
[  716.767594] sdhci: Timeout:  0x00000000 | Int stat: 0x00000000
[  716.767601] sdhci: Int enab: 0x00ff0083 | Sig enab: 0x00ff0083
[  716.767607] sdhci: AC12 err: 0x00000000 | Slot int: 0x00000000
[  716.767613] sdhci: Caps:     0x038021a1 | Caps_1:   0x00000000
[  716.767619] sdhci: Cmd:      0x0000341a | Max curr: 0x00ffffff
[  716.767624] sdhci: Host ctl2: 0x00000000
[  716.767627] sdhci: ===========================================
And after extracting:
[  767.735355] mmc0: Card removed during transfer!
[  767.735364] mmc0: Resetting controller.


Expected results:
No error messages during boot and SD Card should work.


Additional info:
$ lspci
06:04.0 FireWire (IEEE 1394): O2 Micro, Inc. Firewire (IEEE 1394) (rev 02)
06:04.2 SD Host controller: O2 Micro, Inc. Integrated MMC/SD Controller (rev 01)
06:04.3 Mass storage controller: O2 Micro, Inc. Integrated MS/xD Controller (rev 01)

$ lsmod | grep mmc
mmc_core              139264  2 sdhci,sdhci_pci

$ modinfo mmc_core
filename:       /lib/modules/4.11.9-300.fc26.x86_64/kernel/drivers/mmc/core/mmc_core.ko.xz
license:        GPL
depends:        
intree:         Y
vermagic:       4.11.9-300.fc26.x86_64 SMP mod_unload 
signat:         PKCS#7
signer:         
sig_key:        
sig_hashalgo:   md4
parm:           use_spi_crc:bool

...

I tried to boot with options sdhci debug_quirks=0x40 ( http://www.adminempire.com/o2-sd-card-reader-fix-linux/ ) and sdhci debug_quirks2="0x4" ( http://www.0xf8.org/2016/01/workaround-for-broken-o2-micro-sd-card-reader-support-since-linux-kernel-version-4-1-8/ ), but it does not help.

Is there any solution for make this integrated SD-card reader to work (except to blacklisting sdhci and sdhci-pci mods)?
Comment 1 Laura Abbott 2018-02-27 22:40:41 EST
We apologize for the inconvenience.  There is a large number of bugs to go through and several of them have gone stale. The kernel moves very fast so bugs may get fixed as part of a kernel update. Due to this, we are doing a mass bug update across all of the Fedora 26 kernel bugs.
 
Fedora 26 has now been rebased to 4.15.4-200.fc26.  Please test this kernel update (or newer) and let us know if you issue has been resolved or if it is still present with the newer kernel.
 
If you have moved on to Fedora 27, and are still experiencing this issue, please change the version to Fedora 27.
 
If you experience different issues, please open a new bug report for those.
Comment 2 feder 2018-02-28 01:30:54 EST
I use Fedora 27 now.

> If you have moved on to Fedora 27, and are still experiencing this issue,
> please change the version to Fedora 27.

Fixed, version was changed.

> If you experience different issues, please open a new bug report for those.

Bug is reproducible now, sd controller doesn't work. I see same error string during boot:

mmc0: Unknown controller version (16). O2 Micro Integrated MMC/SD Controller (rev 01)

But modinfo output changed a bit:

$ lsmod | grep mmc
mmc_core              172032  2 sdhci,sdhci_pci
[feder@fed-amilo-laptop ~]$ sudo modinfo mmc_core
filename:       /lib/modules/4.15.4-300.fc27.x86_64/kernel/drivers/mmc/core/mmc_core.ko.xz
license:        GPL
depends:        
retpoline:      Y
intree:         Y
name:           mmc_core
vermagic:       4.15.4-300.fc27.x86_64 SMP mod_unload 
sig_id:         PKCS#7
signer:         
sig_key:        
sig_hashalgo:   md4
signature:      30:82:02:CF:06:09:2A:86:48:86:F7:0D:01:07:02:A0:82:02:C0:30:
		82:02:BC:02:01:01:31:0D:30:0B:06:09:60:86:48:01:65:03:04:02:
		01:30:0B:06:09:2A:86:48:86:F7:0D:01:07:01:31:82:02:99:30:82:
		02:95:02:01:01:30:70:30:63:31:0F:30:0D:06:03:55:04:0A:0C:06:
		46:65:64:6F:72:61:31:22:30:20:06:03:55:04:03:0C:19:46:65:64:
		6F:72:61:20:6B:65:72:6E:65:6C:20:73:69:67:6E:69:6E:67:20:6B:
		65:79:31:2C:30:2A:06:09:2A:86:48:86:F7:0D:01:09:01:16:1D:6B:
		65:72:6E:65:6C:2D:74:65:61:6D:40:66:65:64:6F:72:61:70:72:6F:
		6A:65:63:74:2E:6F:72:67:02:09:00:85:33:E3:67:74:01:A5:1D:30:
		0B:06:09:60:86:48:01:65:03:04:02:01:30:0D:06:09:2A:86:48:86:
		F7:0D:01:01:01:05:00:04:82:02:00:A6:39:4A:DC:E1:AA:DD:54:9D:
		75:1C:CC:6D:5A:48:BE:C6:A7:FD:E9:CD:87:4C:FB:B3:81:51:B5:2C:
		AF:5A:B6:33:AA:FB:2B:96:4F:60:40:0E:72:35:16:59:CD:42:83:E7:
		B4:80:1A:4C:5A:B6:5F:00:8B:20:A0:9A:CE:31:92:B4:E7:F4:E1:4E:
		0A:FD:A9:BB:0A:7E:FD:B6:11:83:D3:67:2D:AC:24:5C:75:66:83:C8:
		29:BE:AF:60:53:2C:C3:F5:B9:0B:A2:A0:EF:39:20:21:C6:81:0B:1C:
		F7:98:27:5D:DF:93:0B:D9:1C:06:BF:DC:AD:70:3D:97:19:5D:E5:DE:
		07:73:C0:F9:23:33:E2:C6:A7:DF:E9:3B:B7:B2:66:D4:CA:44:19:7A:
		4E:AC:D5:21:DE:03:55:F8:82:65:6E:85:F4:55:BA:D6:46:A2:7A:6B:
		A1:12:2A:C0:BE:43:E2:C2:15:8D:8B:8E:9F:57:04:49:CF:96:4D:24:
		56:1F:FD:D7:DB:74:CF:0C:F3:42:3E:DA:78:E9:0D:8E:61:07:E4:FC:
		B3:73:C3:FD:2E:8C:64:73:37:9F:D9:04:6D:55:6F:19:B6:72:5D:30:
		6F:A0:0E:2E:55:D4:4C:62:BF:7F:F8:0A:49:E5:8E:2F:72:C5:88:78:
		5C:0F:B9:F3:88:ED:81:FD:56:0C:9E:B6:D5:7F:A5:F4:78:72:E5:4A:
		78:12:DC:1D:4E:1B:7B:AF:18:F6:7B:FF:F4:BE:ED:A4:C1:17:E1:0D:
		A8:24:B3:BA:B6:07:3A:BA:6A:0E:74:14:23:EC:87:23:3A:D3:B4:13:
		68:B1:E4:8C:50:13:BA:E3:24:B9:43:03:3A:0D:27:62:21:77:99:85:
		6C:56:1B:8E:1E:FC:8C:0D:C7:93:37:3F:94:92:22:4B:AF:73:5B:D5:
		8A:53:06:CB:54:E9:EF:4B:14:27:C2:71:94:76:E3:4A:5C:80:01:1B:
		28:A3:96:BE:F6:1B:CB:3C:E3:00:31:4C:7A:78:41:0E:A8:BE:0B:EC:
		D4:13:D7:CE:85:5B:F5:B3:0C:38:5A:95:4F:49:32:F1:4D:0A:E6:4F:
		C7:DF:25:5E:B7:C4:5A:F5:B0:DE:3D:C1:72:34:43:81:75:B6:D2:40:
		98:41:3E:31:B1:23:20:1D:18:E4:34:2A:C2:45:93:16:DA:84:A6:4C:
		BC:3B:17:AF:89:BA:48:90:CD:58:2D:6D:F8:D0:D4:C5:15:62:F8:B9:
		9D:4B:76:A4:78:90:EB:F9:42:04:6C:49:A1:3C:32:02:22:4C:5C:89:
		C1:D9:84:F9:80:D5:C6:ED:74:EE:FA:7B:E5:E7:FB:6D:C8:6D:69:86:
		B9:44:8B
parm:           use_spi_crc:bool

Note You need to log in before you can comment on or make changes to this bug.